## freefilesync 14.2

=== FreeFileSync/Source/Makefile ===
CXX ?= g++
exeName = FreeFileSync_$(shell arch)

CXXFLAGS += -std=c++23 -pipe -DWXINTL_NO_GETTEXT_MACRO -I../.. -I../../zenXml -include "zen/i18n.h" -include "zen/warn_static.h" \
           -Wall -Wfatal-errors -Wmissing-include-dirs -Wswitch-enum -Wcast-align -Wnon-virtual-dtor -Wno-unused-function -Wshadow -Wno-maybe-uninitialized \
           -O3 -DNDEBUG `wx-config --cxxflags --debug=no` -pthread

LDFLAGS += -s `wx-config --libs std, aui, richtext --debug=no` -pthread


CXXFLAGS  += `pkg-config --cflags openssl`
LDFLAGS += `pkg-config --libs   openssl`

CXXFLAGS  += `pkg-config --cflags libcurl`
LDFLAGS += `pkg-config --libs   libcurl`

CXXFLAGS  += `pkg-config --cflags libssh2`
LDFLAGS += `pkg-config --libs   libssh2`

CXXFLAGS  += `pkg-config --cflags gtk+-2.0`
#treat as system headers so that warnings are hidden:
CXXFLAGS  += -isystem/usr/include/gtk-2.0

#support for SELinux (optional)
SELINUX_EXISTING=$(shell pkg-config --exists libselinux && echo YES)
ifeq ($(SELINUX_EXISTING),YES)
CXXFLAGS  += `pkg-config --cflags libselinux` -DHAVE_SELINUX
LDFLAGS += `pkg-config --libs libselinux`
endif

cppFiles=
cppFiles+=application.cpp
cppFiles+=base_tools.cpp
cppFiles+=config.cpp
cppFiles+=ffs_paths.cpp
cppFiles+=icon_buffer.cpp
cppFiles+=localization.cpp
cppFiles+=log_file.cpp
cppFiles+=status_handler.cpp
cppFiles+=base/algorithm.cpp
cppFiles+=base/binary.cpp
cppFiles+=base/comparison.cpp
cppFiles+=base/db_file.cpp
cppFiles+=base/dir_lock.cpp
cppFiles+=base/file_hierarchy.cpp
cppFiles+=base/icon_loader.cpp
cppFiles+=base/multi_rename.cpp
cppFiles+=base/parallel_scan.cpp
cppFiles+=base/path_filter.cpp
cppFiles+=base/speed_test.cpp
cppFiles+=base/structures.cpp
cppFiles+=base/synchronization.cpp
cppFiles+=base/versioning.cpp
cppFiles+=afs/abstract.cpp
cppFiles+=afs/concrete.cpp
cppFiles+=afs/ftp.cpp
cppFiles+=afs/gdrive.cpp
cppFiles+=afs/init_curl_libssh2.cpp
cppFiles+=afs/native.cpp
cppFiles+=afs/sftp.cpp
cppFiles+=ui/batch_config.cpp
cppFiles+=ui/abstract_folder_picker.cpp
cppFiles+=ui/batch_status_handler.cpp
cppFiles+=ui/cfg_grid.cpp
cppFiles+=ui/command_box.cpp
cppFiles+=ui/folder_history_box.cpp
cppFiles+=ui/folder_selector.cpp
cppFiles+=ui/file_grid.cpp
cppFiles+=ui/file_view.cpp
cppFiles+=ui/log_panel.cpp
cppFiles+=ui/tree_grid.cpp
cppFiles+=ui/gui_generated.cpp
cppFiles+=ui/gui_status_handler.cpp
cppFiles+=ui/main_dlg.cpp
cppFiles+=ui/progress_indicator.cpp
cppFiles+=ui/rename_dlg.cpp
cppFiles+=ui/search_grid.cpp
cppFiles+=ui/small_dlgs.cpp
cppFiles+=ui/sync_cfg.cpp
cppFiles+=ui/tray_icon.cpp
cppFiles+=ui/triple_splitter.cpp
cppFiles+=ui/version_check.cpp
cppFiles+=../../libcurl/curl_wrap.cpp
cppFiles+=../../zen/argon2.cpp
cppFiles+=../../zen/file_access.cpp
cppFiles+=../../zen/file_io.cpp
cppFiles+=../../zen/file_path.cpp
cppFiles+=../../zen/file_traverser.cpp
cppFiles+=../../zen/http.cpp
cppFiles+=../../zen/zstring.cpp
cppFiles+=../../zen/format_unit.cpp
cppFiles+=../../zen/legacy_compiler.cpp
cppFiles+=../../zen/open_ssl.cpp
cppFiles+=../../zen/process_priority.cpp
cppFiles+=../../zen/recycler.cpp
cppFiles+=../../zen/resolve_path.cpp
cppFiles+=../../zen/process_exec.cpp
cppFiles+=../../zen/shutdown.cpp
cppFiles+=../../zen/sys_error.cpp
cppFiles+=../../zen/sys_info.cpp
cppFiles+=../../zen/sys_version.cpp
cppFiles+=../../zen/thread.cpp
cppFiles+=../../zen/zlib_wrap.cpp
cppFiles+=../../wx+/darkmode.cpp
cppFiles+=../../wx+/file_drop.cpp
cppFiles+=../../wx+/grid.cpp
cppFiles+=../../wx+/image_tools.cpp
cppFiles+=../../wx+/graph.cpp
cppFiles+=../../wx+/taskbar.cpp
cppFiles+=../../wx+/tooltip.cpp
cppFiles+=../../wx+/image_resources.cpp
cppFiles+=../../wx+/popup_dlg.cpp
cppFiles+=../../wx+/popup_dlg_generated.cpp
cppFiles+=../../xBRZ/src/xbrz.cpp

tmpPath = $(shell dirname "$(shell mktemp -u)")/$(exeName)_Make

objFiles = $(cppFiles:%=$(tmpPath)/ffs/src/%.o)

all: ../Build/Bin/$(exeName)

../Build/Bin/$(exeName): $(objFiles)
	mkdir -p $(dir $@)
	$(CXX) -o $@ $^ $(LDFLAGS)

$(tmpPath)/ffs/src/%.o : %
	mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) -c $< -o $@

clean:
	rm -rf $(tmpPath)
	rm -f ../Build/Bin/$(exeName)

=== FreeFileSync/Source/RealTimeSync/Makefile ===
CXX ?= g++
exeName = RealTimeSync_$(shell arch)

CXXFLAGS += -std=c++23 -pipe -DWXINTL_NO_GETTEXT_MACRO -I../../.. -I../../../zenXml -include "zen/i18n.h" -include "zen/warn_static.h" \
           -Wall -Wfatal-errors -Wmissing-include-dirs -Wswitch-enum -Wcast-align -Wnon-virtual-dtor -Wno-unused-function -Wshadow -Wno-maybe-uninitialized \
           -O3 -DNDEBUG `wx-config --cxxflags --debug=no` -pthread

LDFLAGS += -s `wx-config --libs std, aui, richtext --debug=no` -pthread

#Gtk - support "no button border"
CXXFLAGS  += `pkg-config --cflags gtk+-2.0`
#treat as system headers so that warnings are hidden:
CXXFLAGS  += -isystem/usr/include/gtk-2.0

cppFiles=
cppFiles+=application.cpp
cppFiles+=config.cpp
cppFiles+=gui_generated.cpp
cppFiles+=main_dlg.cpp
cppFiles+=tray_menu.cpp
cppFiles+=monitor.cpp
cppFiles+=folder_selector2.cpp
cppFiles+=../afs/abstract.cpp
cppFiles+=../base/icon_loader.cpp
cppFiles+=../ffs_paths.cpp
cppFiles+=../icon_buffer.cpp
cppFiles+=../localization.cpp
cppFiles+=../../../wx+/darkmode.cpp
cppFiles+=../../../wx+/file_drop.cpp
cppFiles+=../../../wx+/image_tools.cpp
cppFiles+=../../../wx+/image_resources.cpp
cppFiles+=../../../wx+/popup_dlg.cpp
cppFiles+=../../../wx+/popup_dlg_generated.cpp
cppFiles+=../../../wx+/taskbar.cpp
cppFiles+=../../../xBRZ/src/xbrz.cpp
cppFiles+=../../../zen/dir_watcher.cpp
cppFiles+=../../../zen/file_access.cpp
cppFiles+=../../../zen/file_io.cpp
cppFiles+=../../../zen/file_path.cpp
cppFiles+=../../../zen/file_traverser.cpp
cppFiles+=../../../zen/format_unit.cpp
cppFiles+=../../../zen/legacy_compiler.cpp
cppFiles+=../../../zen/resolve_path.cpp
cppFiles+=../../../zen/process_exec.cpp
cppFiles+=../../../zen/shutdown.cpp
cppFiles+=../../../zen/sys_error.cpp
cppFiles+=../../../zen/sys_info.cpp
cppFiles+=../../../zen/sys_version.cpp
cppFiles+=../../../zen/thread.cpp
cppFiles+=../../../zen/zstring.cpp

tmpPath = $(shell dirname "$(shell mktemp -u)")/$(exeName)_Make

objFiles = $(cppFiles:%=$(tmpPath)/ffs/src/rts/%.o)

all: ../../Build/Bin/$(exeName)

../../Build/Bin/$(exeName): $(objFiles)
	mkdir -p $(dir $@)
	$(CXX) -o $@ $^ $(LDFLAGS)

$(tmpPath)/ffs/src/rts/%.o : %
	mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) -c $< -o $@

clean:
	rm -rf $(tmpPath)
	rm -f ../../Build/Bin/$(exeName)

=== debian/changelog ===
freefilesync (14.2-0.1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Bump minimum version of curl BD required.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 15 Mar 2025 15:09:37 -0700

freefilesync (14.2-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Fixed crash when closing progress dialog after sync (Windows)
  * Package updates
    * Add no-wx3.3.patch which disables some features like dark mode.

 -- B. Stack <bgstack15@gmail.com>  Thu, 20 Feb 2025 17:32:25 -0500

freefilesync (14.1-100+stackrpms) UNRELEASED; urgency=low

  * Upstream updates
    * Further dark mode improvements
    * Fixed blurry icons due to image resizing glitch
    * Fixed RealTimeSync process not exiting while in taskbar (Linux)
    * Improved file icon loading performance
    * Improved extension handling for multi-file renaming
    * Mitigate icon size rendering bug for notification emails
    * Close popup dialogs using Ctrl+Enter while ignoring keyboard focus
    * Resume from system tray via single mouse click
    * Avoid white flash when resuming progress dialog from system tray
      (Windows)
    * Increased progress indicator UI update frequency

 -- B. Stack <bgstack15@gmail.com>  Thu, 20 Feb 2025 15:11:32 -0500

freefilesync (14.0-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Dark mode support (Windows 10 20H1, macOS 10.14 (Mojave), Linux)
    * Fixed dock icon progress percentage divergence (macOS)
    * Prevent "App Napp during comparison/synchronization (macOS)
    * Enhance EINVAL error message for unsupported characters
    * Support running with background priority (Linux)
    * Fixed installer access denied when creating shell links (Windows)
    * Improved size and date formatting for file listing (macOS)
    * Improved context menu customization grid
    * Reduced peak memory consumption by 12%
    * Automatically set appropriate text color for config panel background
    * Revived and updated Italian translation

 -- B. Stack <bgstack15@gmail.com>  Mon, 20 Jan 2024 17:41:23 -0500

freefilesync (13.9-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Fixed CURLE_SEND_ERROR: OpenSSL SSL_write: SSL_ERROR_SYSCALL, errno 0
    * Added comparison and sync context menu options for multiple folder
      pairs
    * Show file include/exclude filter directly in tooltip
    * Fixed file not found error when cancelling file up-/download
    * Fixed showing cancelled config log status after nothing to sync
    * Updated translation files

 -- B. Stack <bgstack15@gmail.com>  Sun, 08 Dec 2024 08:09:07 -0500

freefilesync (13.8-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Support raw IPv6 server address for (S)FTP
    * RealTimeSync: Fixed scrollbar when adding/removing folders
    * Don't set sync direction for partial folder pairs
    * Uniquely identify partial folder pairs in error message
    * Fixed network login prompt not showing in Windows 11 24H2

 -- B. Stack <bgstack15@gmail.com>  Mon, 04 Nov 2024 19:28:43 -0500

freefilesync (13.7-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Support copying symlinks between SFTP devices
    * Fixed input focus not being restored after comparison/sync
    * Fixed log file pruning not considering selected configuration
    * Show startup error details when running outside terminal (Linux)

 -- B. Stack <bgstack15@gmail.com>  Sun, 23 Jun 2024 17:52:53 -0400

freefilesync (13.6-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Compact parent path display for medium/large row sizes
    * Fixed crash when mouse inputs are queued due to system lag
    * Don't steal focus from other app when sync progress dialog is shown
    * Fix crackling sound at the beginning of WAV playback (Linux)
    * Prevent middle grid tooltip from covering sync direction
    * Disable Nagle algorithm for SFTP connections
  * Package
    * Use 13.4-patched file_grid for traditional view

 -- B. Stack <bgstack15@gmail.com>  Fri, 10 May 2024 11:23:26 -0400

freefilesync (13.5-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Wrap file grid folder paths instead of truncate
    * Fixed sync operation arrows for RTL layout
    * Fixed FTP hang during connection (libcurl regression)
    * Consider user-defined file time tolerance for DB comparisons
    * Don't log folder pair paths if nothing to sync

 -- B. Stack <bgstack15@gmail.com>  Tue, 02 Apr 2024 09:25:10 -0400

freefilesync (13.4-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Ignore leading/trailing space when matching file names
    * Work around wxWidgets system logger clearing error code
    * Fixed registration info not found after App Translocation (macOS)
    * Avoid modal dialog hang on KDE when compiling with GTK3
    * Change app location without losing Donation Edition status (macOS)

 -- B. Stack <bgstack15@gmail.com>  Fri, 16 Feb 2024 21:07:55 -0500

freefilesync (13.3-101+stackrpms) obs; urgency=low

  * Add dependencies on libselinux1-dev, zlib1g-dev
  * Update some patches from bastif

 -- B. Stack <bgstack15@gmail.com>  Fri, 09 Feb 2024 20:09:21 -0500

freefilesync (13.3-100+stackrpms) obs; urgency=low

    * Upstream updates
      * Completed CASA security assessment for Google Drive
      * Use system temp folder for auto-updating
      * Ignore errors when setting directory attributes is unsupported
      * Save GUI sync log file even when cancelled
      * Fixed Business Edition install over existing installation
      * Updated code signing certificates (Windows)

 -- B. Stack <bgstack15@gmail.com>  Sun, 07 Jan 2024 19:39:08 -0500

freefilesync (13.2-100+stackrpms) obs; urgency=low

    * Upstream updates
      * Complete high-DPI/Retina display support (macOS)
      * Prevent files from being moved to versioning recursively
      * Fixed tooltip line wrap bug for moved files (Windows)
      * Return first FTP parsing error when trying multiple variants


=== debian/control ===
Source: freefilesync
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: B. Stack <bgstack15@gmail.com>
Build-Depends: debhelper-compat (=13),
               g++-12,
               imagemagick,
               libcurl4-openssl-dev (>= 8.12.0),
               libglibmm-2.4-dev,
               libgtk-3-dev,
               libselinux1-dev,
               libssh2-1-dev (>= 1.10),
               libssl-dev (>= 3.0~),
               libwxgtk3.2-dev,
               pkgconf,
               unzip,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://freefilesync.org/

Package: freefilesync
Architecture: any
Multi-Arch: foreign
Depends: xdg-utils, ${misc:Depends}, ${shlibs:Depends}
Description: cross-platform file sync utility, GPL release
 FreeFileSync is a folder comparison and synchronization software that
 creates and manages backup copies of all your important files. Instead
 of copying every file every time, FreeFileSync determines the
 differences between a source and a target folder and transfers only the
 minimum amount of data needed. FreeFileSync is Open Source software,
 available for Windows, Linux and MacOS.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/architecture.mk

include /usr/share/dpkg/buildtools.mk

# Produce .debug_info (used by dh_dwz)
CXXFLAGS += -g

# Enable PIE
#CXXFLAGS += -fpie
#LDFLAGS += -pie

#stackrpms,2: I put APP_NAME_SUFFIX in Makefile
# libatomic stuff is for ubuntu only

%:
	dh $@ --sourcedirectory=FreeFileSync/Source

execute_after_dh_auto_clean:
	# Now, auto_clean RealTimeSync
	dh_auto_clean --sourcedirectory=FreeFileSync/Source/RealTimeSync

execute_after_dh_auto_build:
	# Now, auto_build RealTimeSync
	dh_auto_build --sourcedirectory=FreeFileSync/Source/RealTimeSync

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

override_dh_auto_install:
	# desktop files
	# handled by dh_install through debian/install

	# mimetypes
	# handled by dh_installmime through debian/sharedmimeinfo

	# icons
	unzip -u FreeFileSync/Build/Resources/Icons.zip cfg_batch.png database.png start_sync.png FreeFileSync.png RealTimeSync.png
	for size in 16 24 32 48 64 128 256; do \
	  mkdir -p debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/apps ; \
	  convert FreeFileSync.png -filter Lanczos -resize $${size}x$${size} debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/apps/FreeFileSync.png ; \
	  convert RealTimeSync.png -filter Lanczos -resize $${size}x$${size} debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/apps/RealTimeSync.png ; \
	  mkdir -p debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/mimetypes ; \
	  convert cfg_batch.png -filter Lanczos -resize $${size}x$${size} debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/mimetypes/application-x-freefilesync-batch.png ; \
	  convert database.png -filter Lanczos -resize $${size}x$${size} debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/mimetypes/application-x-freefilesync-db.png ; \
	  convert start_sync.png -filter Lanczos -resize $${size}x$${size} debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/mimetypes/application-x-freefilesync-gui.png ; \
	  convert RealTimeSync.png -filter Lanczos -resize $${size}x$${size} debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/mimetypes/application-x-freefilesync-real.png ; \
	done

## freefilesync 14.3

=== FreeFileSync/Source/Makefile ===
--- 
+++ 
@@ -8,24 +8,24 @@
 LDFLAGS += -s `wx-config --libs std, aui, richtext --debug=no` -pthread
 
 
-CXXFLAGS  += `pkg-config --cflags openssl`
-LDFLAGS += `pkg-config --libs   openssl`
+CXXFLAGS += `pkg-config --cflags openssl`
+LDFLAGS  += `pkg-config --libs openssl`
 
-CXXFLAGS  += `pkg-config --cflags libcurl`
-LDFLAGS += `pkg-config --libs   libcurl`
+CXXFLAGS += `pkg-config --cflags libcurl`
+LDFLAGS  += `pkg-config --libs libcurl` -lidn2
 
-CXXFLAGS  += `pkg-config --cflags libssh2`
-LDFLAGS += `pkg-config --libs   libssh2`
+CXXFLAGS += `pkg-config --cflags libssh2`
+LDFLAGS  += `pkg-config --libs libssh2`
 
-CXXFLAGS  += `pkg-config --cflags gtk+-2.0`
+CXXFLAGS += `pkg-config --cflags gtk+-2.0`
 #treat as system headers so that warnings are hidden:
-CXXFLAGS  += -isystem/usr/include/gtk-2.0
+CXXFLAGS += -isystem/usr/include/gtk-2.0
 
 #support for SELinux (optional)
 SELINUX_EXISTING=$(shell pkg-config --exists libselinux && echo YES)
 ifeq ($(SELINUX_EXISTING),YES)
-CXXFLAGS  += `pkg-config --cflags libselinux` -DHAVE_SELINUX
-LDFLAGS += `pkg-config --libs libselinux`
+CXXFLAGS += `pkg-config --cflags libselinux` -DHAVE_SELINUX
+LDFLAGS  += `pkg-config --libs libselinux`
 endif
 
 cppFiles=

=== debian/changelog ===
freefilesync (14.3-0.1~mx23+1) mx; urgency=medium
  
  * Rebuild for MX Linux.
  * Bump minimum version of curl BD required.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 25 May 2025 15:06:01 -0700

freefilesync (14.3-100+stackrpms) obs; urgency=low

  * Upstream updates
    * Support internationalized domain names (IDN) for (S)FTP and email
    * Log performance statistics for file content comparison
    * Support installation using Ptyxis terminal (Linux)
    * Support pausing countdown towards system shutdown
    * Support KDE Plasma 6 service menu (Linux)
    * Fixed crash on app exit when called by Cron (Linux)

 -- B. Stack <bgstack15@gmail.com>  Thu, 27 Mar 2025 19:49:37 -0400

## freefilesync 14.4

=== debian/changelog ===
freefilesync (14.4-0.1~mx25+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 18 Aug 2025 16:08:01 -0700

## freefilesync 14.5

=== Source/Makefile ===
CXX ?= g++
exeName = FreeFileSync_$(shell arch)

CXXFLAGS += -std=c++23 -pipe -DWXINTL_NO_GETTEXT_MACRO -I../.. -I../../zenXml -include "zen/i18n.h" -include "zen/warn_static.h" \
           -Wall -Wfatal-errors -Wmissing-include-dirs -Wswitch-enum -Wcast-align -Wnon-virtual-dtor -Wno-unused-function -Wshadow -Wno-maybe-uninitialized \
           -O3 -DNDEBUG `wx-config --cxxflags --debug=no` -pthread

LDFLAGS += -s `wx-config --libs std, aui, richtext --debug=no` -pthread


CXXFLAGS += `pkg-config --cflags openssl`
LDFLAGS  += `pkg-config --libs openssl`

CXXFLAGS += `pkg-config --cflags libcurl`
LDFLAGS  += `pkg-config --libs libcurl`

CXXFLAGS += `pkg-config --cflags libidn2`
LDFLAGS  += `pkg-config --libs libidn2`

CXXFLAGS += `pkg-config --cflags libssh2`
LDFLAGS  += `pkg-config --libs libssh2`

CXXFLAGS += `pkg-config --cflags gtk+-2.0`
#treat as system headers so that warnings are hidden:
CXXFLAGS += -isystem/usr/include/gtk-2.0

#support for SELinux (optional)
SELINUX_EXISTING=$(shell pkg-config --exists libselinux && echo YES)
ifeq ($(SELINUX_EXISTING),YES)
CXXFLAGS += `pkg-config --cflags libselinux` -DHAVE_SELINUX
LDFLAGS  += `pkg-config --libs libselinux`
endif

cppFiles=
cppFiles+=application.cpp
cppFiles+=base_tools.cpp
cppFiles+=config.cpp
cppFiles+=ffs_paths.cpp
cppFiles+=icon_buffer.cpp
cppFiles+=localization.cpp
cppFiles+=log_file.cpp
cppFiles+=status_handler.cpp
cppFiles+=base/algorithm.cpp
cppFiles+=base/binary.cpp
cppFiles+=base/comparison.cpp
cppFiles+=base/db_file.cpp
cppFiles+=base/dir_lock.cpp
cppFiles+=base/file_hierarchy.cpp
cppFiles+=base/icon_loader.cpp
cppFiles+=base/multi_rename.cpp
cppFiles+=base/parallel_scan.cpp
cppFiles+=base/path_filter.cpp
cppFiles+=base/speed_test.cpp
cppFiles+=base/structures.cpp
cppFiles+=base/synchronization.cpp
cppFiles+=base/versioning.cpp
cppFiles+=afs/abstract.cpp
cppFiles+=afs/concrete.cpp
cppFiles+=afs/ftp.cpp
cppFiles+=afs/gdrive.cpp
cppFiles+=afs/init_curl_libssh2.cpp
cppFiles+=afs/native.cpp
cppFiles+=afs/sftp.cpp
cppFiles+=ui/batch_config.cpp
cppFiles+=ui/abstract_folder_picker.cpp
cppFiles+=ui/batch_status_handler.cpp
cppFiles+=ui/cfg_grid.cpp
cppFiles+=ui/command_box.cpp
cppFiles+=ui/folder_history_box.cpp
cppFiles+=ui/folder_selector.cpp
cppFiles+=ui/file_grid.cpp
cppFiles+=ui/file_view.cpp
cppFiles+=ui/log_panel.cpp
cppFiles+=ui/tree_grid.cpp
cppFiles+=ui/gui_generated.cpp
cppFiles+=ui/gui_status_handler.cpp
cppFiles+=ui/main_dlg.cpp
cppFiles+=ui/progress_indicator.cpp
cppFiles+=ui/rename_dlg.cpp
cppFiles+=ui/search_grid.cpp
cppFiles+=ui/small_dlgs.cpp
cppFiles+=ui/sync_cfg.cpp
cppFiles+=ui/tray_icon.cpp
cppFiles+=ui/triple_splitter.cpp
cppFiles+=ui/version_check.cpp
cppFiles+=../../libcurl/curl_wrap.cpp
cppFiles+=../../zen/argon2.cpp
cppFiles+=../../zen/file_access.cpp
cppFiles+=../../zen/file_io.cpp
cppFiles+=../../zen/file_path.cpp
cppFiles+=../../zen/file_traverser.cpp
cppFiles+=../../zen/http.cpp
cppFiles+=../../zen/zstring.cpp
cppFiles+=../../zen/format_unit.cpp
cppFiles+=../../zen/legacy_compiler.cpp
cppFiles+=../../zen/open_ssl.cpp
cppFiles+=../../zen/process_priority.cpp
cppFiles+=../../zen/recycler.cpp
cppFiles+=../../zen/resolve_path.cpp
cppFiles+=../../zen/process_exec.cpp
cppFiles+=../../zen/shutdown.cpp
cppFiles+=../../zen/sys_error.cpp
cppFiles+=../../zen/sys_info.cpp
cppFiles+=../../zen/sys_version.cpp
cppFiles+=../../zen/thread.cpp
cppFiles+=../../zen/zlib_wrap.cpp
cppFiles+=../../wx+/darkmode.cpp
cppFiles+=../../wx+/file_drop.cpp
cppFiles+=../../wx+/grid.cpp
cppFiles+=../../wx+/image_tools.cpp
cppFiles+=../../wx+/graph.cpp
cppFiles+=../../wx+/taskbar.cpp
cppFiles+=../../wx+/tooltip.cpp
cppFiles+=../../wx+/image_resources.cpp
cppFiles+=../../wx+/popup_dlg.cpp
cppFiles+=../../wx+/popup_dlg_generated.cpp
cppFiles+=../../xBRZ/src/xbrz.cpp

tmpPath = $(shell dirname "$(shell mktemp -u)")/$(exeName)_Make

objFiles = $(cppFiles:%=$(tmpPath)/ffs/src/%.o)

all: ../Build/Bin/$(exeName)

../Build/Bin/$(exeName): $(objFiles)
	mkdir -p $(dir $@)
	$(CXX) -o $@ $^ $(LDFLAGS)

$(tmpPath)/ffs/src/%.o : %
	mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) -c $< -o $@

clean:
	rm -rf $(tmpPath)
	rm -f ../Build/Bin/$(exeName)

=== Source/RealTimeSync/Makefile ===
CXX ?= g++
exeName = RealTimeSync_$(shell arch)

CXXFLAGS += -std=c++23 -pipe -DWXINTL_NO_GETTEXT_MACRO -I../../.. -I../../../zenXml -include "zen/i18n.h" -include "zen/warn_static.h" \
           -Wall -Wfatal-errors -Wmissing-include-dirs -Wswitch-enum -Wcast-align -Wnon-virtual-dtor -Wno-unused-function -Wshadow -Wno-maybe-uninitialized \
           -O3 -DNDEBUG `wx-config --cxxflags --debug=no` -pthread

LDFLAGS += -s `wx-config --libs std, aui, richtext --debug=no` -pthread


CXXFLAGS += `pkg-config --cflags gtk+-2.0`
#treat as system headers so that warnings are hidden:
CXXFLAGS += -isystem/usr/include/gtk-2.0

cppFiles=
cppFiles+=application.cpp
cppFiles+=config.cpp
cppFiles+=gui_generated.cpp
cppFiles+=main_dlg.cpp
cppFiles+=tray_menu.cpp
cppFiles+=monitor.cpp
cppFiles+=folder_selector2.cpp
cppFiles+=../afs/abstract.cpp
cppFiles+=../base/icon_loader.cpp
cppFiles+=../ffs_paths.cpp
cppFiles+=../icon_buffer.cpp
cppFiles+=../localization.cpp
cppFiles+=../../../wx+/darkmode.cpp
cppFiles+=../../../wx+/file_drop.cpp
cppFiles+=../../../wx+/image_tools.cpp
cppFiles+=../../../wx+/image_resources.cpp
cppFiles+=../../../wx+/popup_dlg.cpp
cppFiles+=../../../wx+/popup_dlg_generated.cpp
cppFiles+=../../../wx+/taskbar.cpp
cppFiles+=../../../xBRZ/src/xbrz.cpp
cppFiles+=../../../zen/dir_watcher.cpp
cppFiles+=../../../zen/file_access.cpp
cppFiles+=../../../zen/file_io.cpp
cppFiles+=../../../zen/file_path.cpp
cppFiles+=../../../zen/file_traverser.cpp
cppFiles+=../../../zen/format_unit.cpp
cppFiles+=../../../zen/legacy_compiler.cpp
cppFiles+=../../../zen/resolve_path.cpp
cppFiles+=../../../zen/process_exec.cpp
cppFiles+=../../../zen/shutdown.cpp
cppFiles+=../../../zen/sys_error.cpp
cppFiles+=../../../zen/sys_info.cpp
cppFiles+=../../../zen/sys_version.cpp
cppFiles+=../../../zen/thread.cpp
cppFiles+=../../../zen/zstring.cpp

tmpPath = $(shell dirname "$(shell mktemp -u)")/$(exeName)_Make

objFiles = $(cppFiles:%=$(tmpPath)/ffs/src/rts/%.o)

all: ../../Build/Bin/$(exeName)

../../Build/Bin/$(exeName): $(objFiles)
	mkdir -p $(dir $@)
	$(CXX) -o $@ $^ $(LDFLAGS)

$(tmpPath)/ffs/src/rts/%.o : %
	mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) -c $< -o $@

clean:
	rm -rf $(tmpPath)
	rm -f ../../Build/Bin/$(exeName)

=== debian/changelog ===
freefilesync (14.5-0.1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 15 Oct 2025 21:34:15 -0700

freefilesync (14.4-0.1~mx23+1) mx; urgency=medium

  * New upstream release.
  * Edit ffs_gcc.patch to use gcc-12.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 18 Aug 2025 16:08:01 -0700

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Priority: optional
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: B. Stack <bgstack15@gmail.com>
-Build-Depends: debhelper-compat (=13),
+Build-Depends: debhelper (>=13~),
                g++-12,
                imagemagick,
                libcurl4-openssl-dev (>= 8.12.0),
-               libglibmm-2.4-dev,
+               libglibmm-2.4-dev | glibmm24-devel,
                libgtk-3-dev,
                libselinux1-dev,
                libssh2-1-dev (>= 1.10),
@@ -23,10 +23,10 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: xdg-utils, ${misc:Depends}, ${shlibs:Depends}
-Description: cross-platform file sync utility, GPL release
+Description: cross-platform file sync utility, gpl release
  FreeFileSync is a folder comparison and synchronization software that
  creates and manages backup copies of all your important files. Instead
  of copying every file every time, FreeFileSync determines the
  differences between a source and a target folder and transfers only the
  minimum amount of data needed. FreeFileSync is Open Source software,
- available for Windows, Linux and MacOS.
+ available for Windows, Linux and macOS.

=== debian/rules ===
--- 
+++ 
@@ -33,11 +33,6 @@
 	# Now, auto_build RealTimeSync
 	dh_auto_build --sourcedirectory=FreeFileSync/Source/RealTimeSync
 
-# No dbgsym packages:
-override_dh_strip:
-	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
-	dh_strip --no-automatic-dbgsym
-
 override_dh_auto_install:
 	# desktop files
 	# handled by dh_install through debian/install
@@ -57,3 +52,8 @@
 	  convert start_sync.png -filter Lanczos -resize $${size}x$${size} debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/mimetypes/application-x-freefilesync-gui.png ; \
 	  convert RealTimeSync.png -filter Lanczos -resize $${size}x$${size} debian/tmp/usr/share/icons/hicolor/$${size}x$${size}/mimetypes/application-x-freefilesync-real.png ; \
 	done
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym

=== debian/watch ===
# You must remove unused comment lines for the released package.
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/FreeFileSync.*\.tar\.gz/FreeFileSync-$1\.tar\.gz/g \
  https://gitlab.com/opensource-tracking/FreeFileSync/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*

## freefilesync 14.6

=== Source/RealTimeSync/Makefile ===
--- 
+++ 
@@ -8,9 +8,9 @@
 LDFLAGS += -s `wx-config --libs std, aui, richtext --debug=no` -pthread
 
 
-CXXFLAGS += `pkg-config --cflags gtk+-2.0`
+CXXFLAGS += `pkg-config --cflags gtk+-3.0`
 #treat as system headers so that warnings are hidden:
-CXXFLAGS += -isystem/usr/include/gtk-2.0
+CXXFLAGS += -isystem/usr/include/gtk-3.0
 
 cppFiles=
 cppFiles+=application.cpp

=== debian/changelog ===
freefilesync (14.6-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 17 Dec 2025 20:13:57 -0800

freefilesync (14.6-1xtradeb1.2404.1) noble; urgency=medium

  * New upstream release.

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sun, 07 Dec 2025 19:19:46 +0100

freefilesync (14.5-1xtradeb1.2404.1) noble; urgency=medium

  * New upstream release.

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sat, 04 Oct 2025 09:19:11 +0200

freefilesync (14.4-1xtradeb1.2404.1) noble; urgency=medium

  * New upstream release.

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Sat, 26 Jul 2025 22:04:32 +0200

freefilesync (14.3-1xtradeb1.2404.1) noble; urgency=medium

  * New upstream release.

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Mon, 07 Apr 2025 08:09:09 +0200

freefilesync (14.2-1xtradeb1.2404.1) noble; urgency=medium

  * New upstream release.

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Fri, 21 Feb 2025 21:44:32 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 # You must remove unused comment lines for the released package.
-#export DH_VERBOSE = 1
+export DH_VERBOSE = 1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 #export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
@@ -19,8 +19,23 @@
 #CXXFLAGS += -fpie
 #LDFLAGS += -pie
 
-#stackrpms,2: I put APP_NAME_SUFFIX in Makefile
-# libatomic stuff is for ubuntu only
+# define APP_NAME_SUFFIX
+DPKG_VENDOR = $(shell dpkg-vendor --query vendor)
+CPPFLAGS += -DAPP_NAME_SUFFIX='L" by ${DPKG_VENDOR}"'
+
+# It is sometimes required to build with a specific version of g++ because
+# upstream sometimes used features that are available only in recent versions.
+# This is therefore also required to build backports
+# CXX := $(CXX)-12
+
+# Check if we need to link to libatomic
+# Used to be required on mipsel, sh4, armhf/raspbian
+# but also on Ubuntu 20.04 (focal)
+IS_ATOMIC_LINKING_REQUIRED = $(shell $(CXX) -std=c++2b -o /dev/null debian/material/libatomic_check.cpp > /dev/null 2>&1 || echo "yes")
+ifeq ($(IS_ATOMIC_LINKING_REQUIRED),yes)
+$(warning linking to libatomic is required)
+LDFLAGS += -latomic
+endif
 
 %:
 	dh $@ --sourcedirectory=FreeFileSync/Source
@@ -29,9 +44,12 @@
 	# Now, auto_clean RealTimeSync
 	dh_auto_clean --sourcedirectory=FreeFileSync/Source/RealTimeSync
 
+override_dh_auto_build:
+	dh_auto_build --sourcedirectory=FreeFileSync/Source -- CXX=$(CXX)
+
 execute_after_dh_auto_build:
 	# Now, auto_build RealTimeSync
-	dh_auto_build --sourcedirectory=FreeFileSync/Source/RealTimeSync
+	dh_auto_build --sourcedirectory=FreeFileSync/Source/RealTimeSync -- CXX=$(CXX)
 
 override_dh_auto_install:
 	# desktop files

## freefilesync 14.7

=== Source/Makefile ===
--- 
+++ 
@@ -20,9 +20,9 @@
 CXXFLAGS += `pkg-config --cflags libssh2`
 LDFLAGS  += `pkg-config --libs libssh2`
 
-CXXFLAGS += `pkg-config --cflags gtk+-2.0`
+CXXFLAGS += `pkg-config --cflags gtk+-3.0`
 #treat as system headers so that warnings are hidden:
-CXXFLAGS += -isystem/usr/include/gtk-2.0
+CXXFLAGS += -isystem/usr/include/gtk-3.0
 
 #support for SELinux (optional)
 SELINUX_EXISTING=$(shell pkg-config --exists libselinux && echo YES)

=== debian/changelog ===
freefilesync (14.7-1~mx25) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 27 Jan 2026 21:07:37 -0800

freefilesync (14.7-1xtradeb1.2510.1) questing; urgency=medium

  * New upstream release.

 -- Jhonny Oliveira <jhonny.oliveira@gmail.com>  Thu, 22 Jan 2026 07:56:23 +0100

=== debian/control ===
Source: freefilesync
Section: non-free/utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Jhonny Oliveira <jhonny.oliveira@gmail.com>
# XSBC-Original-Maintainer: Fab Stz <fabstz-it@yahoo.fr>
Build-Depends: debhelper-compat (= 13),
               imagemagick,
               libcurl4-openssl-dev (>= 7.84),
               libgtk-3-dev,
               libidn2-dev,
               libselinux1-dev,
               libssh2-1-dev (>= 1.10),
               libssl-dev (>= 3.0~),
               libwxgtk3.2-dev,
               pkgconf,
               unzip,
               zlib1g-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://freefilesync.org/
Vcs-Browser: https://salsa.debian.org/bastif/freefilesync
Vcs-Git: https://salsa.debian.org/bastif/freefilesync.git
XS-Autobuild: yes

Package: freefilesync
Architecture: alpha amd64 arm64 armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 loong64 mips64el mipsel ppc64el riscv64 sh4 x32
Depends: xdg-utils, ${misc:Depends}, ${shlibs:Depends}
Description: Cross-platform file sync utility with GUI (GPL release)
 FreeFileSync is a folder comparison and synchronization software that
 creates and manages backup copies of all your important files. Instead
 of copying every file every time, FreeFileSync determines the
 differences between a source and a target folder and transfers only the
 minimum amount of data needed. FreeFileSync is Open Source software,
 available for Windows, Linux and macOS.
 .
 This is the "GPL release" which uses the sources as published by the author,
 as opposed to the "FreeFileSync Donation Edition".

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,7 @@
 #!/usr/bin/make -f
-# You must remove unused comment lines for the released package.
+
 export DH_VERBOSE = 1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
@@ -14,10 +12,6 @@
 
 # Produce .debug_info (used by dh_dwz)
 CXXFLAGS += -g
-
-# Enable PIE
-#CXXFLAGS += -fpie
-#LDFLAGS += -pie
 
 # define APP_NAME_SUFFIX
 DPKG_VENDOR = $(shell dpkg-vendor --query vendor)
@@ -52,12 +46,6 @@
 	dh_auto_build --sourcedirectory=FreeFileSync/Source/RealTimeSync -- CXX=$(CXX)
 
 override_dh_auto_install:
-	# desktop files
-	# handled by dh_install through debian/install
-
-	# mimetypes
-	# handled by dh_installmime through debian/sharedmimeinfo
-
 	# icons
 	unzip -u FreeFileSync/Build/Resources/Icons.zip cfg_batch.png database.png start_sync.png FreeFileSync.png RealTimeSync.png
 	for size in 16 24 32 48 64 128 256; do \
